#!/bin/bash

# Copyright (c) 2012-2013 Cloudera, Inc. All rights reserved.

set -e
set -x

# Time marker for both stderr and stdout
date; date 1>&2

# set impala configuration directory
export IMPALA_CONF_DIR=${CONF_DIR}/impala-conf
export HADOOP_CONF_DIR=${CONF_DIR}/hadoop-conf
export HIVE_CONF_DIR=${CONF_DIR}/hive-conf
export HBASE_CONF_DIR=${CONF_DIR}/hbase-conf

FLAG_FILE=$IMPALA_CONF_DIR/$2

# Update path to configuration directory in the flagfile
perl -pi -e "s#{{CMF_CONF_DIR}}#$CONF_DIR#g" ${FLAG_FILE}

if [ "impalad" = "$1" ]; then
  CHECK_SHORT_CIRCUIT_READS=$3
  DN_DATA_DIR=$4
  if [[ "true" = "$CHECK_SHORT_CIRCUIT_READS" && -e $DN_DATA_DIR ]]; then
    # Check that the DN data dirs are actually accessible by the configured
    # Impala user.
    echo "Testing readability of DataNode data dirs for short circuit reads"
    if [ -r $DN_DATA_DIR ]; then
      echo "Valid setup: $DN_DATA_DIR is accesible for short circuit reads"
    else
      echo "Invalid setup: $DN_DATA_DIR is not accessible for short circuit reads"
      exit 1
    fi
  fi
  exec impalad --flagfile=${FLAG_FILE}
elif [ "statestore" = "$1" ]; then
  exec statestored --flagfile=${FLAG_FILE}
fi
