// Copyright (c) 2012 Cloudera, Inc.  All rights reserved.

/*global Sammy: false, undefined: true, setTimeout:false, location: false, console: false, define: false, ko: false, $: false */
define([
	"cloudera/cmf/hdfs/WizardWithHostAssignmentViewModel",
	"cloudera/form/ListBuilder",
	"cloudera/Util"
], function (WizardWithHostAssignmentViewModel, ListBuilder, Util) {
	"use strict";

	return WizardWithHostAssignmentViewModel.extend({
		init: function (options) {
			this._super.apply(this, arguments);
			var self = this;

			self.mountPoints = new ListBuilder({
				values: options.data.mountPoints
			});

			self.next = function () {
				var urlParams, onResponse = function (response) {
					var filteredJsonResponse = Util.filterJsonResponseError(response);
					if (filteredJsonResponse.message === "OK") {
						self.leave();
					} else if (filteredJsonResponse.message) {
						$.publish("showError", [filteredJsonResponse.message]);
					}
				};

				urlParams = self.getNameserviceInfoParam();
				self.fetchingData(true);
				$.post(options.executeUrl, urlParams, onResponse);
			};

			self.getNameserviceInfoParam = function () {
				var mountPoints = [];

				$.each(self.mountPoints.values(), function(i, item) {
					mountPoints.push(item.value());
				});

				var nameserviceInfo = {
					name : options.data.name,
					mountPoints : mountPoints
				};

				return {
					"nameserviceJson": JSON.stringify(nameserviceInfo)
				};
			};

			$("#nameServiceInfo").validate();
		}
	});
});
