// (c) Copyright 2012 Cloudera, Inc. All rights reserved.
define([
	"cloudera/Util",
	"cloudera/chart/AnyChart",
	"cloudera/layout/AjaxLink"
], function(Util, AnyChart, AjaxLink) {

	return function(options) {
		var onPointClick = function(e) {
			jQuery.publish("heatmapCellSelectionChanged", [e.data.ID]);
			return selectCellById(e.data.ID);
		};

		var selectCellById = function(id) {
			var $heatmapSubjectLoader = $(".heatmapSubjectLoader");
			var href = $heatmapSubjectLoader.attr("data-href-template");
			href = href.replace("{id}", id);
			$heatmapSubjectLoader.attr("href", href);
			$heatmapSubjectLoader.AjaxLink('click');
		};

		var params = $.extend({}, options);
		params.xmlUrl = options.heatmapUrl;

		var anyChart = new AnyChart(params, options.heatmapId);

		var chart = anyChart.getChart();
		chart.addEventListener('pointClick', onPointClick);

		return {
			selectCellById: selectCellById
		};
	};
});
